## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 6;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global srcname MonkeyType

%if 0%{?python3_version_nodots} >= 312
# some tests currently fail
%bcond_with all_tests
%else
%bcond_without all_tests
%endif

Name:           monkeytype
Version:        23.3.0
Release:        %autorelease
Summary:        Generating Python type annotations from sampled production types
License:        BSD-3-Clause
URL:            https://github.com/instagram/%{srcname}
# PyPI source has no tests
# Source:        %%{pypi_source %%{srcname}}
Source:         %{url}/archive/v%{version}/%{srcname}-%{version}.tar.gz

BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-devel
# Pipfile not supported yet
# Test dependencies:
BuildRequires:  python3dist(pytest)
BuildRequires:  python3dist(django)

%py_provides python%{python3_pkgversion}-%{name}

%global _description %{expand:
MonkeyType collects runtime types of function arguments and return values, and
can automatically generate stub files or even add draft type annotations
directly to your Python code based on the types collected at runtime.}

%description %{_description}


%prep
%autosetup -p1 -n %{srcname}-%{version}


%generate_buildrequires
%pyproject_buildrequires -r


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files %{name}


%check
%pyproject_check_import
%if %{with all_tests}
%pytest -v
%else
# FAILED tests/test_tracing.py::TestTraceCalls::test_callee_throws_recovers - A...
# FAILED tests/test_tracing.py::TestTraceCalls::test_nested_callee_throws_recovers
# FAILED tests/test_tracing.py::TestTraceCalls::test_caller_handles_callee_exception
# FAILED tests/test_tracing.py::TestTraceCalls::test_generator_trace - Assertio...
# FAILED tests/test_tracing.py::TestTraceCalls::test_return_none - AssertionErr...
# FAILED tests/test_tracing.py::TestTraceCalls::test_access_property - Assertio...
EXCLUDES=" not test_callee_throws_recovers"
EXCLUDES+=" and not test_nested_callee_throws_recovers"
EXCLUDES+=" and not test_caller_handles_callee_exception"
EXCLUDES+=" and not test_generator_trace and not test_return_none"
EXCLUDES+=" and not test_access_property"
%pytest -v -k "$EXCLUDES"
%endif


%files -f %{pyproject_files}
%license LICENSE
%doc CHANGES.rst CODE_OF_CONDUCT.md CONTRIBUTING.rst README.rst
%{_bindir}/%{name}


%changelog
## START: Generated by rpmautospec
* Fri Jan 17 2025 Fedora Release Engineering <releng@fedoraproject.org> - 23.3.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 23.3.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Fri Jun 07 2024 Python Maint <python-maint@redhat.com> - 23.3.0-4
- Rebuilt for Python 3.13

* Thu Jan 25 2024 Fedora Release Engineering <releng@fedoraproject.org> - 23.3.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 23.3.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Sep 06 2023 Michel Lind <salimma@fedoraproject.org> - 23.3.0-1
- Update to 23.3.0
- Use SPDX license identifier
- Temporarily disable failing tests on Python 3.12+

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 22.2.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Jun 29 2023 Python Maint <python-maint@redhat.com> - 22.2.0-3
- Rebuilt for Python 3.12

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 22.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Tue Sep 27 2022 Michel Alexandre Salim <salimma@fedoraproject.org> - 22.2.0-1
- Update to 22.2.0; fix issues with Python 3.11's changes to Tuple[()]

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 21.5.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Jun 20 2022 Python Maint <python-maint@redhat.com> - 21.5.0-3
- Rebuilt for Python 3.11

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 21.5.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Dec 21 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 21.5.0-1
- Initial Fedora package
## END: Generated by rpmautospec
